extend test suite to check for authentication denial when
[monkeysphere.git] / tests / basic
index a917f9f2657ec59fcd5e7465cf549251ae89c40c..46ba63c1cda77e439f8dfaf9e741cc9d48c53976 100755 (executable)
@@ -2,17 +2,16 @@
 
 # Tests to ensure that the monkeysphere is working
 
-# Author: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
-# Date: 2008-09-13 13:40:15-0400
+# Authors: 
+#   Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+#   Jameson Rollins <jrollins@fifthhorseman.net>
+# Copyright: 2008
+# License: GPL v3 or later
 
-# these tests might be best run under fakeroot, particularly the
-# "server-side" tests.  Using fakeroot, they should be able to be run
+# these tests should all be able to
 # as a non-privileged user.
 
-# NOTE: these tests have *not* themselves been tested yet
-# (2008-09-13).  Please exercise with caution!
-
-# fail on fail
+# all subcommands in this script should complete without failure:
 set -e
 
 # gpg command for test admin user
@@ -20,15 +19,32 @@ gpgadmin() {
     GNUPGHOME="$TEMPDIR"/admin/.gnupg gpg "$@"
 }
 
-# cleanup:
-cleanup() {
+launch_sshd() {
+    socat EXEC:"/usr/sbin/sshd -f ${SSHD_CONFIG} -i -D -e" "UNIX-LISTEN:${SOCKET}" 2> "$TEMPDIR"/sshd.log &
+    export SSHD_PID=$!
+
+    while [ ! -S "$SOCKET" ] ; do
+       sleep 1
+    done
+}
 
-    echo
+ssh_test() {
+    ssh-agent bash -c \
+       "monkeysphere subkey-to-ssh-agent && ssh -F $TEMPDIR/testuser/.ssh/config testhost true"
+}
+
+failed_cleanup() {
+    # FIXME: can we be more verbose here?
+    echo 'FAILED!'
     read -p "press enter to cleanup and remove tmp:"
 
-    if ( jobs %1 >/dev/null 2>/dev/null ) ; then 
+    cleanup
+}
+
+cleanup() {
+    if ( ps "$SSHD_PID" >/dev/null ) ; then 
        echo "### stopping still-running sshd..."
-       kill %1
+       kill "$SSHD_PID"
     fi
 
     echo "### removing temp dir..."
@@ -38,7 +54,7 @@ cleanup() {
 }
 
 ## setup trap
-trap cleanup EXIT
+trap failed_cleanup EXIT
 
 ## set up some variables to ensure that we're operating strictly in
 ## the tests, not system-wide:
@@ -63,7 +79,7 @@ export MONKEYSPHERE_SYSSHAREDIR="$TESTDIR"/../src
 export MONKEYSPHERE_MONKEYSPHERE_USER="$USER"
 export MONKEYSPHERE_CHECK_KEYSERVER=false
 
-SSHD_CONFIG="$TEMPDIR"/sshd_config
+export SSHD_CONFIG="$TEMPDIR"/sshd_config
 export SOCKET="$TEMPDIR"/ssh-socket
 
 # copy in admin and testuser home to tmp
@@ -71,20 +87,26 @@ echo "### copying admin and testuser homes..."
 cp -a "$TESTDIR"/home/admin "$TEMPDIR"/
 cp -a "$TESTDIR"/home/testuser "$TEMPDIR"/
 
-cat <<EOF > "$TEMPDIR"/testuser/.ssh/config
+cat <<EOF >> "$TEMPDIR"/testuser/.ssh/config
 UserKnownHostsFile $TEMPDIR/testuser/.ssh/known_hosts
+ProxyCommand $TEMPDIR/testuser/.ssh/proxy-command %h %p $SOCKET
 EOF
 
-cat <<EOF > "$TEMPDIR"/testuser/.monkeysphere/monkeysphere.conf
+cat <<EOF >> "$TEMPDIR"/testuser/.monkeysphere/monkeysphere.conf
 KNOWN_HOSTS=$TEMPDIR/testuser/.ssh/known_hosts
 EOF
 
+# set up a simple default monkeysphere-server.conf
+cat <<EOF >> "$TEMPDIR"/monkeysphere-server.conf
+AUTHORIZED_USER_IDS="$TEMPDIR/testuser/.monkeysphere/authorized_user_ids"
+EOF
 
 ### SERVER TESTS
 
 # setup monkeysphere temp gnupghome directories
 mkdir -p -m 750 "$MONKEYSPHERE_SYSDATADIR"/gnupg-host
 mkdir -p -m 700 "$MONKEYSPHERE_SYSDATADIR"/gnupg-authentication
+mkdir -p -m 700 "$MONKEYSPHERE_SYSDATADIR"/authorized_keys
 cat <<EOF > "$MONKEYSPHERE_SYSDATADIR"/gnupg-authentication/gpg.conf
 primary-keyring ${MONKEYSPHERE_SYSDATADIR}/gnupg-authentication/pubring.gpg
 keyring ${MONKEYSPHERE_SYSDATADIR}/gnupg-host/pubring.gpg
@@ -123,25 +145,59 @@ EOF
 
 # launch test sshd with the new host key.
 echo "### starting sshd..."
-socat EXEC:"/usr/sbin/sshd -f ${SSHD_CONFIG} -i -d -d -d -D -e" "UNIX-LISTEN:${SOCKET}" 2> "$TEMPDIR"/sshd.log &
+launch_sshd
 
 ### TESTUSER TESTS
 
 # generate an auth subkey for the test user
 echo "### generating key for testuser..."
-MONKEYSPHERE_GNUPGHOME="$TEMPDIR"/testuser/.gnupg \
-SSH_ASKPASS=echo \
-    monkeysphere gen-subkey --expire 0
+export GNUPGHOME="$TEMPDIR"/testuser/.gnupg
+export SSH_ASKPASS="$TEMPDIR"/testuser/.ssh/askpass
+export MONKEYSPHERE_HOME="$TEMPDIR"/testuser/.monkeysphere
+
+monkeysphere gen-subkey --expire 0
 
 # add server key to testuser keychain
 echo "### export server key to testuser..."
-gpgadmin --armor --export "$HOSTKEYID" | \
-    GNUPGHOME="$TEMPDIR"/testuser/.gnupg gpg --import
+gpgadmin --armor --export "$HOSTKEYID" | gpg --import
+
+# teach the "server" about the testuser's key
+echo "### export testuser key to server..."
+gpg --export testuser | monkeysphere-server gpg-authentication-cmd --import
+echo "### update server authorized_keys file for this testuser..."
+monkeysphere-server update-users "$USER"
 
 # connect to test sshd, using monkeysphere-ssh-proxycommand to verify
 # the identity before connection.  This should work in both directions!
 echo "### testuser connecting to sshd socket..."
-PROXY_COMMAND="monkeysphere-ssh-proxycommand --no-connect %h && socat STDIO UNIX:${SOCKET}"
-GNUPGHOME="$TEMPDIR"/testuser/.gnupg \
-MONKEYSPHERE_HOME="$TEMPDIR"/testuser/.monkeysphere \
- ssh -F "$TEMPDIR"/testuser/.ssh/config -v -v -v -oProxyCommand="$PROXY_COMMAND" testhost
+ssh_test
+
+# kill the previous sshd process if it's still running
+kill "$SSHD_PID"
+
+# now remove the testuser's authorized_user_ids file and reupdate
+# authorized_keys file...
+echo "### removing testuser authorized_user_ids and reupdating authorized_keys..."
+rm -f "$TEMPDIR"/testuser/.monkeysphere/authorized_user_ids
+monkeysphere-server update-users "$USER"
+
+# restart the sshd
+echo "### restarting sshd..."
+launch_sshd
+
+# and make sure the user can no longer connect
+echo "### testuser attempting to connect to sshd socket..."
+# FIXME: this prompts for the passphrase for the default identity
+# file.  how can this be avoided?
+ssh_test || SSH_RETURN="$?"
+if [ "$SSH_RETURN" != '255' ] ; then
+    exit
+fi
+
+trap - EXIT
+
+echo
+echo "Monkeysphere basic tests completed successfully!"
+echo
+
+cleanup